package test;

import com.sun.star.awt.ActionEvent;
import com.sun.star.awt.XControl;
import com.sun.star.awt.XControlContainer;
import com.sun.star.awt.XControlModel;
import com.sun.star.awt.XDialog;
import com.sun.star.awt.XDialogProvider;
import com.sun.star.awt.tree.ExpandVetoException;
import com.sun.star.awt.tree.TreeExpansionEvent;
import com.sun.star.awt.tree.XMutableTreeDataModel;
import com.sun.star.awt.tree.XMutableTreeNode;
import com.sun.star.awt.tree.XTreeControl;
import com.sun.star.awt.tree.XTreeExpansionListener;
import com.sun.star.beans.XPropertySet;
import com.sun.star.lang.EventObject;
import com.sun.star.lang.XComponent;
import com.sun.star.lang.XMultiComponentFactory;
import com.sun.star.script.provider.XScriptContext;
import com.sun.star.uno.Exception;
import com.sun.star.uno.UnoRuntime;
import com.sun.star.uno.XComponentContext;

public class TreeTest {
	
	public static class TreeExpansionListener implements XTreeExpansionListener
	{

		@Override
		public void disposing(EventObject arg0) {
		}

		@Override
		public void requestChildNodes(TreeExpansionEvent arg0) {
			System.out.println("requestChildNodes");
		}

		@Override
		public void treeCollapsed(TreeExpansionEvent arg0) {
			System.out.println("treeCollapsed");
		}

		@Override
		public void treeCollapsing(TreeExpansionEvent arg0)
				throws ExpandVetoException {
			System.out.println("treeCollapsing");
		}

		@Override
		public void treeExpanded(TreeExpansionEvent arg0) {
			System.out.println("treeExpanded");
		}

		@Override
		public void treeExpanding(TreeExpansionEvent arg0)
				throws ExpandVetoException {
			System.out.println("treeExpanding");
		}
		
	}
	
	public static void showTreeFromButton(XScriptContext xScriptContext, ActionEvent ev) 
	{
		showTree(xScriptContext);
	}
	
	
	public static void showTree(XScriptContext xScriptContext)
	{
		XComponentContext xContext = xScriptContext.getComponentContext();
		XMultiComponentFactory xMcf = xContext.getServiceManager();
		
		try {
			Object dp = xMcf.createInstanceWithContext("com.sun.star.awt.DialogProvider", xContext);
			XDialogProvider xDialogProv = UnoRuntime.queryInterface(XDialogProvider.class, dp);
			XDialog xDialog = xDialogProv.createDialog("vnd.sun.star.script:Standard.Dialog1?location=application");
			
			XControlContainer xControlContainer = UnoRuntime.queryInterface(XControlContainer.class, xDialog);
			XControl xControl = xControlContainer.getControl("tree");
			
			XTreeControl xTreeControl = UnoRuntime.queryInterface(XTreeControl.class, xControl);
			xTreeControl.addTreeExpansionListener(new TreeExpansionListener());
			XControlModel xControlModel = xControl.getModel();
			XPropertySet xPropSet = UnoRuntime.queryInterface(XPropertySet.class, xControlModel);
			
			Object treeDataModel = xMcf.createInstanceWithContext("com.sun.star.awt.tree.MutableTreeDataModel", xContext);
			
			XMutableTreeDataModel xMutableTreeDataModel = UnoRuntime.queryInterface(
					XMutableTreeDataModel.class, treeDataModel);
			
			xPropSet.setPropertyValue("SelectionType", com.sun.star.view.SelectionType.SINGLE);
			xPropSet.setPropertyValue("DataModel", xMutableTreeDataModel);
			
			System.out.println(xMutableTreeDataModel == null);
			
			XMutableTreeNode xRootNode = xMutableTreeDataModel.createNode("ROOT", false);
			xMutableTreeDataModel.setRoot(xRootNode);
			
			XMutableTreeNode xChildNode = xMutableTreeDataModel.createNode("Child1", false);
			xRootNode.appendChild(xChildNode);
			
			XMutableTreeNode xChildNode2 = xMutableTreeDataModel.createNode("Child2", false);
			xChildNode.appendChild(xChildNode2);
			
			xDialog.execute();
			UnoRuntime.queryInterface(XComponent.class, xDialog).dispose();
			
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	public static void main()
	{
	}
}
